type binop' =
  | Add'
  | Mul'

type expr' =
  | Const' of int
  | Binop' of binop' * expr' * expr'

let rec eval' = function
  | Const' i -> i
  | Binop'(Add', u, v) -> add (eval' u) (eval' v)
  | Binop'(Mul', u, v) -> mul (eval' u) (eval' v)

let rec eval' = function
  | Const' i -> i
  | Binop'(Add', u, v) -> add (eval' u) (eval' v)
  | Binop'(Mul', u, v) -> mul (eval' u) (eval' v)

let rec eval'' = function
  | Const x -> x
  | Add(x, x') -> add (eval'' x) (eval'' x')
  | Mul(x, x') -> mul (eval'' x) (eval'' x')

let rec expr2expr' = function
  | Const i -> Const' i
  | Add(u, v) -> Binop'(Add', expr2expr' u, expr2expr' v)
  | Mul(u, v) -> Binop'(Mul', expr2expr' u, expr2expr' v)
