
# 12 "expr_higher.tex"
type expr =
| Const of int
| Add of expr * expr
| Mul of expr * expr
| Abs of (expr -> expr option)
| App of expr * expr

# 23 "expr_higher.tex"
let rec eval e = match e with
| Const i -> Some(Const i)
| Add ( u , v ) -> 
   begin match (eval u, eval v) with
   | (Some (Const i1), Some (Const i2)) -> Some(Const (add i1 i2))
   | _ -> None
   end
| Mul ( u , v ) ->
   begin match (eval u, eval v) with
   | (Some (Const i1), Some (Const i2)) -> Some(Const (mul i1 i2))
   | _ -> None
   end
| Abs f -> Some(Abs f)
| App(u, v) ->
   begin match eval u with
   | Some(Abs f) -> begin match eval v with None -> None | Some x -> f x end
   | _ -> None
   end
