
# 29 "expr_larger.tex"
type expr =
  | Var of id
  | Abs of id * expr
  | App of expr * expr
  | Tup of expr
  | Proj of expr

# 38 "expr_larger.tex"
let rec eval env e =
  match e with
  | Var x -> assoc x env
  | Abs(x, f) -> Some (Abs(x, f))
  | App(e1,e2) ->
    begin match eval env e1 with
     | Some (Abs(x,f)) ->
        begin match eval env e2 with
        | Some v -> eval (Cons((x,v), env)) f
        | None -> None
        end
     | Some (Tup _) -> None     (* Type error        *)
     | None -> None             (* error propagation *)
     | Some _ -> fail ()        (* Not a value ?!    *)    
    end
  | Tup(e) ->
     begin match eval env e with
     | Some v -> Some (Tup v)
     | None -> None
     end
  | Proj(e) ->
     begin match eval env e with
     | Some (Tup v) -> Some v
     | Some (Abs _) -> None     (* Type error        *)        
     | None -> None             (* error propagation *) 
     | Some _ -> fail ()        (* Not a value ?!    *)    
     end
(* eval : (id * expr) list -> expr -> expr option *)

# 90 "expr_larger.tex"
type value =
  | VAbs of id * expr
  | VTup of value
