
# 97 "expr_larger.tex"
type ornament expr_value : expr => value with
  | Abs(x, e) => VAbs(x, e)
  | Tup(e) => VTup(e) when e : expr_value
  | Var(x) => ~
  | App(e1,e2) => ~
  | Proj(e) => ~

# 107 "expr_larger.tex"
let eval' = lifting eval : (id * expr_value) list -> expr -> expr_value option

# 141 "expr_larger.tex"
type value' =
  | VClosure' of id * (id * value') list * expr
  | VTup' of value'

# 149 "expr_larger.tex"
type ornament value_value' : value => value' with
  | VAbs(x, e) => VClosure'(x, _, e)
  | VTup(v) => VTup'(v) when v : value_value'

# 160 "expr_larger.tex"
let eval'' = lifting eval' with
  | ornament * <- value_value', @id
  | * <- env

# 192 "expr_larger.tex"
let eval'' = lifting eval' with | ornament * <- value_value', @id

# 225 "expr_larger.tex"
let eval'' = lifting eval' with
  | ornament * <- value_value', @id
  | #35 <- env

# 310 "expr_larger.tex"
type expr' =
  | Var' of id
  | Abs' of id * expr'
  | Closure' of id * (id * expr') list * expr'
  | App' of expr' * expr'
  | Tup' of expr'
  | Proj' of expr'

# 319 "expr_larger.tex"
type ornament expr_expr' : expr => expr' with
  | Var(x) => Var'(x)
  | Abs(x, e) => (Abs'(x, e) | Closure'(x,_,e)) when e : expr_expr'
  | App(e1, e2) => App'(e1, e2) when e1 e2 : expr_expr'
  | Tup(e) => Tup'(e) when e : expr_expr'
  | Proj(e) => Proj'(e) when e : expr_expr'

# 330 "expr_larger.tex"
let eval' = lifting eval : (id * expr_expr') list -> expr_expr' -> expr_expr' option with
  | ornament * <- @id
  | #51 <- Right env

# 374 "expr_larger.tex"
let rec eval' env e = match e with
    | Var' x -> assoc x env
    | Abs'(x, e) -> Some (Closure'(x, env, e))
    | Closure'(x, _, e) -> Some (Closure'(x, env, e))
    | App'(e1, e2) ->
      begin match eval' env e1 with
        | (None | Some (Tup' _)) -> None
        | Some (Var' _) -> fail ()
        | Some (Abs'(x, e)) ->
          begin match eval' env e2 with
            | None -> None
            | Some v -> eval' (Cons((x, v), env)) e
          end
        | Some (Closure'(x, closure_env, e)) ->
          begin match eval' env e2 with
            | None -> None
            | Some v -> eval' (Cons((x, v), closure_env (* was env *))) e
          end
        | Some (App'(_, _)) -> fail ()
        | Some (Proj' _) -> fail ()
      end
    | Tup' e ->
      begin match eval' env e with
        | None -> None
        | Some e -> Some (Tup' e)
      end
    | Proj' e ->
      begin match eval' env e with
        | ((None | Some (Abs'(_, _)))
          | Some (Closure'(_, _, _))) -> None
        | Some (Var' _) -> fail ()
        | Some (App'(_, _)) -> fail ()
        | Some (Tup' e) -> Some e
        | Some (Proj' _) -> fail ()
      end

# 415 "expr_larger.tex"
type ornament expr'_expr : expr' => expr with
  | Var'(x) => Var(x)
  | Abs'(x,e) => Abs(x,e) when e : expr'_expr
  | App'(e1,e2) => App(e1,e2) when e1 e2 : expr'_expr
  | Tup'(e) => Tup(e) when e : expr'_expr
  | Proj'(e) => Proj(e) when e : expr'_expr
  | Closure'(x,env,e) => ~ when e : expr'_expr
type ornament expr'_value' : expr' => value' with
  | Abs'(x, e) => ~ when e : expr'_expr
  | Closure'(x,env,e) => VClosure'(x,env,e) when env : (id * expr'_value') list, e : expr'_expr
  | Tup'(e) => VTup'(e) when e : expr'_value'
  | Var'(x) => ~
  | App'(e1,e2) => ~
  | Proj'(e) => ~

# 433 "expr_larger.tex"
let eval'' = lifting eval' : (id * expr'_value') list -> expr'_expr -> expr'_value' option
