
# 36 "expr_smaller.tex"
type expr =
  | Var of id
  | Abs of id * expr
  | App of expr * expr
  | Tup of expr
  | Proj of expr

# 45 "expr_smaller.tex"
let rec eval env e =
  match e with
  | Var x -> assoc x env
  | Abs(x, f) -> Some (Abs(x, f))
  | App(e1,e2) ->
    bind (eval env e1) (fun v -> match v with
     | Abs(x,f) ->
        bind (eval env e2) (fun v -> eval (Cons((x,v), env)) f)
     | Tup _ -> None     (* Type error        *)
     |  _ -> fail ()     (* Not a value ?!    *)    
    )
  | Tup(e) ->
     bind (eval env e) (fun v -> Some (Tup v))
  | Proj(e) ->
     bind (eval env e) (fun v -> match v with 
     | Tup v -> Some v
     | Abs _ -> None     (* Type error        *)        
     | _ -> fail ()      (* Not a value ?!    *)    
     )
(* val eval : (id * expr) list -> expr -> expr option *)

# 88 "expr_smaller.tex"
type value =
  | VAbs of id * expr
  | VTup of value
