type expr' =
  | Val of value
  | App' of expr' * expr'
and value =
  | Const' of bool
  | Abs' of (value -> expr')

let rec eval' e = match e with
    | Val (Const' i) -> Some (Const' i)
    | Val (Abs' f) -> Some (Abs' f)
    | App'(u, v) ->
      begin match eval' u with
        | (None | Some (Const' _)) -> None
        | Some (Abs' f) ->
          begin match eval' v with
            | None -> None
            | Some x -> eval' (f x)
          end
      end

let cval' x = match x with
    | Const' i -> Val (Const' i)
    | Abs' f -> Val (Abs' f)

let id' = Val (Abs' (fun x -> cval' x))

let xx' = Val (Abs' (fun x -> App'(cval' x, cval' x)))

let z' = App'(App'(xx', id'), Val (Const' True))

let v' _x = eval' z'
