
# 11 "generic.tex"
type 'a gsum =
  | GSumZ of 'a gprod
  | GSumS of 'a gsum
and 'a gprod =
  | GNil
  | GCons of 'a gval * 'a gprod
and 'a gval =
  | GData of 'a gsum
  | GParam of 'a

# 34 "generic.tex"
let gmap f =
  let rec gsum x = match x with
    | GSumZ p -> GSumZ (gprod p)
    | GSumS s -> GSumS (gsum s)
  and gprod x = match x with
    | GNil -> GNil
    | GCons(v,vs) -> GCons(gval v, gprod vs)
  and gval x = match x with
    | GData s -> GData (gsum s)
    | GParam y -> GParam (f y)
  in
  gval

# 109 "generic.tex"
let gmap_unfolded f =
  let rec gsum0 x = match x with
    | GSumZ p -> GSumZ (gprodCons2 p)
    | GSumS s -> GSumS (gsum0 s)
  and gsum1 x = match x with
    | GSumZ p -> GSumZ (gprodNil0 p)
    | GSumS s -> GSumS (gsum0 s)
  and gprodNil0 x = match x with
    | GNil -> GNil
    | GCons(v,vs) -> GCons(gval_list v, gprodNil0 vs)
  and gprodCons2 x = match x with
    | GNil -> GNil
    | GCons(v,vs) -> GCons(gval_val v, gprodCons1 vs)
  and gprodCons1 x = match x with
    | GNil -> GNil
    | GCons(v,vs) -> GCons(gval_list v, gprodCons0 vs)
  and gprodCons0 x = match x with
    | GNil -> GNil
    | GCons(v,vs) -> GCons(gval_list v, gprodCons0 vs)
  and gval_list x = match x with
    | GData s -> GData (gsum1 s)
    | GParam y -> GParam (f y)
  and gval_val x = match x with
    | GData s -> GData (gsum1 s)
    | GParam y -> GParam (f y)
  in
  gval_list
