type 'a list =
  | Nil
  | Cons of 'a * 'a list

type u = U

type 'a alist =
  | ANil of u
  | ACons of ('a * ('a alist * u))

let map_alist f = let rec gsum0 x = gprodCons2 x
   and gsum1 x = match x with
      | ANil p -> ANil (gprodNil0 p)
      | ACons s -> ACons (gsum0 s)
   and gprodNil0 x = match x with
      | U -> U
   and gprodCons2 x = match x with
      | (v, vs) -> (gval_val v, gprodCons1 vs)
   and gprodCons1 x = match x with
      | (v, vs) -> (gval_list v, gprodCons0 vs)
   and gprodCons0 x = match x with
      | U -> U
   and gval_list x = gsum1 x
   and gval_val x = f x
  in
  gval_list

let map_list f = let rec gsum0 x = gprodCons2 x
   and gsum1 x = match x with
      | Nil ->
        begin match gprodNil0 U with
          | U -> Nil
        end
      | Cons(x, xs) ->
        begin match gsum0 (x, xs) with
          | (x, xs) -> Cons(x, xs)
        end
   and gprodNil0 x = match x with
      | U -> U
   and gprodCons2 x = match x with
      | (v, vs) -> (gval_val v, gprodCons1 vs)
   and gprodCons1 x = let x1 = gprodCons0 U in
    let xs = gval_list x in
    match x1 with
      | U -> xs
   and gprodCons0 x = match x with
      | U -> U
   and gval_list x = gsum1 x
   and gval_val x = f x
  in
  gval_list
