type 'a list =
  | Nil
  | Cons of 'a * 'a list

let rec _append m n = match m with
    | Nil -> n
    | Cons(_, m') -> Cons(#2, _append m' n)

let rec append m n = match m with
    | Nil -> n
    | Cons(a, m') -> Cons(a, append m' n)

let rec map_list f n = match n with
    | Nil -> Nil
    | Cons(x, n') -> Cons(f x, map_list f n')

let rec fold_list s z n = match n with
    | Nil -> z
    | Cons(_, n') -> s (fold_list s z n')
