
# 14 "natlist_extended.tex"
type nat =
  | Z
  | S of nat

# 19 "natlist_extended.tex"
type 'a list =
  | Nil
  | Cons of 'a * 'a list

type 'a bilist =
  | Nil0
  | Cons1 of 'a * 'a bilist
  | Cons2 of 'a * 'a bilist

type 'a maybelist =
  | NilM
  | ConsNone of 'a maybelist
  | ConsSome of 'a * 'a maybelist

# 35 "natlist_extended.tex"
let id = fun x -> x
let zero = Z

let rec add m n =
  match m with
  | Z -> n
  | S m' -> S(add m' n)

# 48 "natlist_extended.tex"
type ornament 'a natlist : nat => 'a list with
  | Z => Nil
  | S n => Cons (_, n) when n : 'a natlist

let id2 = lifting id

let nil = lifting zero : _ natlist

# 64 "natlist_extended.tex"
let _append = lifting add : _ natlist -> _ natlist -> _ natlist

# 74 "natlist_extended.tex"
let append = lifting add : _ natlist -> _ natlist -> _ natlist with
  | #2 <- match m with Cons(a,_) -> a 

# 86 "natlist_extended.tex"
let rec append ml nl = 
    match ml with
    | Nil -> nl
    | Cons(a,ml') -> Cons(a, append ml' nl)

# 94 "natlist_extended.tex"
let add2 = lifting add with
  | ornament * <- @id

# 108 "natlist_extended.tex"
type ornament 'a listbilist : 'a list => 'a bilist with
  | Nil => Nil0
  | Cons(a,l) => (Cons1(a,l) | Cons2(a,l)) when l : 'a listbilist

# 115 "natlist_extended.tex"
let append2 = lifting append with
  | ornament * <- listbilist
  | #2 <-match ml with Cons1(_,_) -> Left(()) | Cons2(_,_) -> Right(())

# 130 "natlist_extended.tex"
type ornament natunit : nat => () with
  | Z => ()
  | S(n) => ~ when n : natunit

# 136 "natlist_extended.tex"
type ornament 'a natmaybelist : nat => 'a maybelist with
  | Z => NilM
  | S(x) => (ConsNone(x) | ConsSome(_,x)) when x : 'a natmaybelist

# 142 "natlist_extended.tex"
let add0 = lifting add with
  | ornament * <- natunit

let addmaybe = lifting add with
  | ornament * <- natmaybelist
  | #2 <- match m with ConsNone(_) -> Left(()) | ConsSome(a,_) -> Right(a)

# 166 "natlist_extended.tex"
let rec equal_nat m n =
  match (m, n) with
  | (Z, Z) -> True
  | (S m', S n') -> equal_nat m' n'
  | _ -> False

# 174 "natlist_extended.tex"
let equal_length = lifting equal_nat : _ natlist -> _ natlist -> bool
  with | ornament * <- @id
