type 'a list =
  | Nil
  | Cons of 'a * 'a list

type ('a,'b) listlike =
  | Nil_
  | Cons_ of 'a * 'b

let listlike n = match n with
    | Nil -> Nil_
    | Cons(x, x1) -> Cons_(x, x1)

let rec fold_list f n = match n with
    | Nil -> f Nil_
    | Cons(x, x1) -> f (Cons_(x, fold_list f x1))

let append n m = fold_list
  (fun z ->
      match z with
        | Nil_ -> m
        | Cons_(x, n) -> Cons(x, n))
  n
