type 'a map =
  | MEmpty
  | MNode of 'a map * elt * 'a * 'a map * int

let minvalid_arg = MEmpty

let mheight t = match t with
    | MEmpty -> i0
    | MNode(_, _, _, _, h) -> h

let mcreate l vb r = match vb with
    | Box (a, x) ->
      begin match l with
        | MEmpty ->
          begin match r with
            | MEmpty ->
              begin match gte i0 i0 with
                | True -> MNode(l, a, x, r, plus i0 i1)
                | False -> MNode(l, a, x, r, plus i0 i1)
              end
            | MNode(_, _, _, _, n) ->
              begin match gte i0 n with
                | True -> MNode(l, a, x, r, plus i0 i1)
                | False -> MNode(l, a, x, r, plus n i1)
              end
          end
        | MNode(_, _, _, _, n) ->
          begin match r with
            | MEmpty ->
              begin match gte n i0 with
                | True -> MNode(l, a, x, r, plus n i1)
                | False -> MNode(l, a, x, r, plus i0 i1)
              end
            | MNode(_, _, _, _, n1) ->
              begin match gte n n1 with
                | True -> MNode(l, a, x, r, plus n i1)
                | False -> MNode(l, a, x, r, plus n1 i1)
              end
          end
      end

let mbal l vb r = match vb with
    | Box (a, x) ->
      begin match l with
        | MEmpty ->
          begin match r with
            | MEmpty ->
              begin match gt i0 (plus i0 i2) with
                | True -> minvalid_arg
                | False ->
                  begin match gt i0 (plus i0 i2) with
                    | True -> minvalid_arg
                    | False ->
                      begin match gte i0 i0 with
                        | True ->
                          MNode(l, a, x, r, plus i0 i1)
                        | False ->
                          MNode(l, a, x, r, plus i0 i1)
                      end
                  end
              end
            | MNode(l1, v, x1, r1, n) ->
              begin match gt i0 (plus n i2) with
                | True -> minvalid_arg
                | False ->
                  begin match gt n (plus i0 i2) with
                    | True ->
                      begin match gte (mheight r1)
                      (mheight l1)
                        with
                        | True ->
                          mcreate
                          (mcreate l (Box (a, x)) l1)
                          (Box (v, x1))
                          r1
                        | False ->
                          begin match l1 with
                            | MEmpty -> minvalid_arg
                            | MNode(l1, v1, x2, r, _) ->
                              mcreate
                              (mcreate l (Box (a, x)) l1)
                              (Box (v1, x2))
                              (mcreate r (Box (v, x1)) r1)
                          end
                      end
                    | False ->
                      begin match gte i0 n with
                        | True ->
                          MNode(l, a, x, r, plus i0 i1)
                        | False ->
                          MNode(l, a, x, r, plus n i1)
                      end
                  end
              end
          end
        | MNode(l1, v, x1, r1, n) ->
          begin match r with
            | MEmpty ->
              begin match gt n (plus i0 i2) with
                | True ->
                  begin match gte (mheight l1) (mheight r1)
                    with
                    | True ->
                      mcreate l1 (Box (v, x1))
                      (mcreate r1 (Box (a, x)) r)
                    | False ->
                      begin match r1 with
                        | MEmpty -> minvalid_arg
                        | MNode(l, v1, x2, r1, _) ->
                          mcreate
                          (mcreate l1 (Box (v, x1)) l)
                          (Box (v1, x2))
                          (mcreate r1 (Box (a, x)) r)
                      end
                  end
                | False ->
                  begin match gt i0 (plus n i2) with
                    | True -> minvalid_arg
                    | False ->
                      begin match gte n i0 with
                        | True ->
                          MNode(l, a, x, r, plus n i1)
                        | False ->
                          MNode(l, a, x, r, plus i0 i1)
                      end
                  end
              end
            | MNode(l2, v1, x2, r2, n1) ->
              begin match gt n (plus n1 i2) with
                | True ->
                  begin match gte (mheight l1) (mheight r1)
                    with
                    | True ->
                      mcreate l1 (Box (v, x1))
                      (mcreate r1 (Box (a, x)) r)
                    | False ->
                      begin match r1 with
                        | MEmpty -> minvalid_arg
                        | MNode(l, v1, x2, r1, _) ->
                          mcreate
                          (mcreate l1 (Box (v, x1)) l)
                          (Box (v1, x2))
                          (mcreate r1 (Box (a, x)) r)
                      end
                  end
                | False ->
                  begin match gt n1 (plus n i2) with
                    | True ->
                      begin match gte (mheight r2)
                      (mheight l2)
                        with
                        | True ->
                          mcreate
                          (mcreate l (Box (a, x)) l2)
                          (Box (v1, x2))
                          r2
                        | False ->
                          begin match l2 with
                            | MEmpty -> minvalid_arg
                            | MNode(l1, v, x1, r, _) ->
                              mcreate
                              (mcreate l (Box (a, x)) l1)
                              (Box (v, x1))
                              (mcreate r (Box (v1, x2)) r2)
                          end
                      end
                    | False ->
                      begin match gte n n1 with
                        | True ->
                          MNode(l, a, x, r, plus n i1)
                        | False ->
                          MNode(l, a, x, r, plus n1 i1)
                      end
                  end
              end
          end
      end

let rec madd xb t = match xb with
    | Box (a, x) ->
      begin match t with
        | MEmpty -> MNode(MEmpty, a, x, MEmpty, i1)
        | MNode(l, v, x1, r, _) ->
          begin match compare a v with
            | Eq -> t
            | Lt ->
              mbal (madd (Box (a, x)) l) (Box (v, x1)) r
            | Gt ->
              mbal l (Box (v, x1)) (madd (Box (a, x)) r)
          end
      end

let msingleton xb = match xb with
    | Box (a, x) -> MNode(MEmpty, a, x, MEmpty, i1)

let rec mmin_binding t = match t with
    | MEmpty -> None
    | MNode(MEmpty, u, x, _, _) -> Some (u, x)
    | MNode(MNode(l, v, x, r, n), _, _, _, _) ->
      mmin_binding (MNode(l, v, x, r, n))

let rec mmax_binding t = match t with
    | MEmpty -> None
    | MNode(_, u, x, MEmpty, _) -> Some (u, x)
    | MNode(_, _, _, MNode(l, v, x, r, n), _) ->
      mmax_binding (MNode(l, v, x, r, n))
