
# 13 "unfolding_generic.tex"
type 'a gen =
  | Pair of 'a gen * 'a gen
  | Value of 'a
  | Unit

# 21 "unfolding_generic.tex"
let rec gen_map f x = match x with
  | Pair(u,v) -> Pair(gen_map f u, gen_map f v)
  | Value x -> Value (f x)
  | Unit -> Unit

# 29 "unfolding_generic.tex"
type 'a list =
  | Nil
  | Cons of 'a * 'a list

# 36 "unfolding_generic.tex"
type ornament 'a gen_list : 'a gen => 'a list with
| Unit => Nil
| Pair(x, xs) => Cons(x, xs) when x : 'a gen_elem, xs : 'a gen_list
| Value x => ~
and 'a gen_elem : 'a gen => 'a with
| Value x => x
| Unit => ~
| Pair(x, y) => ~

# 48 "unfolding_generic.tex"
#(push_env)
let map_list = lifting gen_map : ('a -> 'b) -> 'a gen_list -> 'b gen_list
#(pop_env)

# 62 "unfolding_generic.tex"
#(mode inline)
let map_list = lifting gen_map : ('a -> 'b) -> 'a gen_list -> 'b gen_list
#(mode noinline)

# 75 "unfolding_generic.tex"
type 'a tree =
  | Leaf
  | Node of 'a * 'a tree * 'a tree

# 80 "unfolding_generic.tex"
type ornament 'a gen_tree : 'a gen => 'a tree with
| Unit => Leaf
| Pair(v : 'a gen_value, (l, r) : 'a gen_treepair) => Node(v,l,r)
| Value x => ~
and 'a gen_value : 'a gen => 'a with
| Value x => x
| Unit => ~
| Pair(x,y) => ~
and 'a gen_treepair : 'a gen => 'a tree * 'a tree with
| Unit => ~
| Pair(l : 'a gen_tree, r : 'a gen_tree) => (l, r)
| Value x => ~

# 94 "unfolding_generic.tex"
#(push_env)
let map_tree = lifting gen_map : ('a -> 'b) -> 'a gen_tree -> 'b gen_tree
#(pop_env)

# 113 "unfolding_generic.tex"
#(mode inline)
let map_tree = lifting gen_map : ('a -> 'b) -> 'a gen_tree -> 'b gen_tree
#(mode noinline)
