type 'a gen =
  | Pair of 'a gen * 'a gen
  | Value of 'a
  | Unit

type 'a list =
  | Nil
  | Cons of 'a * 'a list

let rec map_list f x = match x with
    | Nil -> Nil
    | Cons(x, x1) -> Cons(gen_map_auto1 f x, map_list f x1)
 and gen_map_auto1 f x = f x

let rec map_list f x = match x with
    | Nil -> Nil
    | Cons(x, x1) -> Cons(f x, map_list f x1)

type 'a tree =
  | Leaf
  | Node of 'a * 'a tree * 'a tree

let rec map_tree f x = match x with
    | Leaf -> Leaf
    | Node(x, l, r) ->
      begin match gen_map_auto3 f (l, r) with
        | (l, r) -> Node(gen_map_auto4 f x, l, r)
      end
 and gen_map_auto3 f x = match x with
    | (x, x1) -> (map_tree f x, map_tree f x1)
 and gen_map_auto4 f x = f x

let rec map_tree f x = match x with
    | Leaf -> Leaf
    | Node(x, l, r) -> Node(f x, map_tree f l, map_tree f r)
