type 'a list =
  | Nil
  | Cons of 'a * 'a list

type 'a vec3 = Vec3 of 'a * 'a * 'a

let rec map_tuple f x = match x with
    | Vec3(x, y, z) ->
      begin match map_auto1 f (y, z) with
        | (y, z) -> Vec3(f x, y, z)
      end
 and map_auto1 f x = match x with
    | (x, x1) -> (f x, map_auto2 f x1)
 and map_auto2 f x = match map_auto3 f () with
    | () -> f x
 and map_auto3 f x = match x with
    | () -> ()

let map_tuple f x = match x with
    | Vec3(x, y, z) -> Vec3(f x, f y, f z)
