let debug_mode = ref false
let display_info = ref false
let noisy_output = ref false
let bind_names = ref true
let output_things = ref true
let bind_names = ref true
let output_things = ref true
let echo_decls = ref false
let enable_unfolding = ref false
let enable_autolifting = ref false
let enable_inlining = ref false

let is_flag s = String.length s >= 2 && String.sub s 0 2 = "--"
let flag_root s = String.sub s 2 (String.length s - 2) (* Assume is_flag s *)
let process_flag = function
  | "info" -> display_info:=true
  | "noinfo" -> display_info:=false
  | "debug" -> debug_mode:=true
  | "nodebug" -> debug_mode:=false
  | "noisy" -> noisy_output:=true
  | "nonoisy" -> noisy_output:=false
  | "copy" ->
     echo_decls := true
  | "library" ->
     echo_decls := false;
     bind_names := true;
     output_things := false
  | "lifting" ->
     echo_decls := false;
     bind_names := true;
     output_things := true
  | "input" -> bind_names := false
  | "unfold" -> enable_unfolding := true
  | "autolift" -> enable_autolifting := true
  | "inline" -> enable_inlining := true
  | "noinline" -> enable_inlining := false
  | _ -> invalid_arg "process_flag"
