type int = Int
type op = OAdd | OMul
let add u v = Int
let mul u v = Int

type expr =
  | Const of int
  | Add of expr * expr
  | Mul of expr * expr

let rec eval e = match e with
    | Const i -> i
    | Add ( u , v ) -> add (eval u)  (eval v)
    | Mul ( u , v ) -> mul (eval u)  (eval v)

let rec copy e = match e with
    | Const i -> Const i
    | Add ( u , v ) ->  Add ( copy u , copy v )
    | Mul ( u , v ) -> Mul ( copy u , copy v )

type exprpair = EP of expr * expr

let eval_pair n = match n with
    | EP(e1, e2) -> (eval e1, eval e2)
