type one =  Z0
type two =  Z1 | Z2

    
type ornament two_one : two => one with
   | Z1 => Z0
   | Z2 => Z0

(* This is accepted but should be rejected as non injective: this is similar 
   to a wildcard on the left, and will lead to errorneous liftings, 
   always ignoring Z2 pattern_matching clauses
*)

type two' =  Z1' | Z2'
       
let add1 x = match x with
   | Z1 -> Z1'
   | _  -> Z2'

let add2 x = match x with
   | Z2 -> Z2'
   | _  -> Z1'

let add_one1 = lifting add1 : two_one -> two'
let add_one2 = lifting add2 : two_one -> two'

(* This is analoguous to having an underscore on the left pattern of 
   an ornament, for example *) 

type one2 = Z of bool

type ornament one2_one : one2 => one with
  | Z True => Z0
  | Z False => Z0

(* While the following 

type ornament one2_one : one2 => one with
  | Z _ => Z0

is [correctly] rejected.  This would amount to check both codes are
 equivalent. Could be solved with type theory in color---if the code 
does not *) 

