type 'a list = Nil | Cons of 'a * 'a list
type 'a option = None | Some of 'a
val assert_false : 'a


    
(* Exemple canonique de François *)
(* Internal error: Empty/incomplete pattern matching *)
type ornament 'a get : 'a option => 'a with
   | Some x => x
   | None => ~

let copy x = match x with
   | Some x -> Some x
   | None -> None

   let get = lifting copy : 'a option -> 'a get
   (* does not produce the expected value *)
   

(* Version liste *)
(* Bizarrement, on a une autre erreur *)
(* internal error: exception Not_found *)
(* type ornament 'a listtuple : 'a list => 'a with *)
(*    | Cons (x, Nil) => x *)

(* Avec des paires *)
(* Bizarrement, on retrouve la première erreur *)
(* Internal error: Empty/incomplete pattern matching *)
type ornament 'a listpair : 'a list => 'a * 'a with
   | Cons (x, Cons (y, Nil)) => (x, y)
   | Cons (x, Cons (y, Cons (h, t))) => ~
   | Cons (x, Nil) => ~
   | Nil => ~

let check2 z = match z with
   | Cons (x, Cons (y, Nil)) -> Cons (x, Cons (y, Nil))
   | _ -> assert_false

let list2pair = lifting check2 : 'a list -> 'a listpair


let map2 f x = match x with
   | Nil -> Nil
   | Cons (x, Nil) -> Cons (f x, Nil)
   | Cons (x, Cons (y, Nil)) -> Cons (f x, Cons (f y, Nil))
   | Cons (x, Cons (y, t)) ->
     let rec map x = match x with
       | Cons (x, t) -> Cons (f x, map t)
       | Nil -> Nil in
     Cons (f x, Cons (f y, map t))

let distrib_pair = lifting map2 : ('a -> 'b) -> 'a listpair -> 'b listpair

let rec map f x = match x with
   | Cons (x, Cons (y, Nil)) -> Cons (f x, Cons (f y, Nil))
   | Nil -> Nil
   | Cons (x, Nil) -> Cons (f x, Nil)
   | Cons (x, Cons (y, t)) -> Cons (f x, Cons (f y, assert_false))

let distrib_pair = lifting map : ('a -> 'b) -> _ listpair -> _ listpair
   

(* let rec map f x = match x with *)
(*    | Cons (x, Cons (y, Nil)) -> Cons (f x, Cons (f y, Nil)) *)
(*    | Cons (x, Cons (y, t)) -> Cons (f x, Cons (f y, map f t)) *)
(*    | Cons (h, t) -> Cons (f h, map f t) *)
(*    | Nil -> Nil *)

   
   
   
(* (\* Une autre version incomplète *\) *)
(* (\* internal error: exception Not found *\) *)
(* type ornament 'a listtuple : 'a list => 'a option with *)
(*    | Cons (y, Nil) => Some y *)
(*    | Nil => None *)
(*    | Cons (y, Cons (h,t)) => ~ *)


type ornament 'a listlist1 : 'a list => 'a * 'a list with
| Nil => ~
| Cons (h, t) => (h, t) 
    

let head x = match x with
  Nil -> assert_false
| Cons (h, t) -> h

let head1 = lifting head : 'a listlist1 -> 'a

let tail x = match x with
  Nil -> assert_false
| Cons (h, t) -> t

(* Internal error: exception Stack overflow *)
(* let tail1 = lifting tail : 'a listlist1 -> 'a *)
      
let tail1 = lifting tail : 'a listlist1 -> 'a list

let rec map f x = match x with
   | Nil -> Nil
   | Cons (h, t) -> Cons (f h, map f t)

(* unification fails---shouldn't it be the lifting that fails? *)
(* let map1 = lifting map : ('a -> 'b) -> 'a listlist1 -> 'b listlist1 *)
         
let map_unfolded (* could be automatized *) f x = match x with
   | Nil -> Nil
   | Cons (h, t) ->
       let rec map f x = match x with
       | Nil -> Nil
       | Cons (h, t) -> Cons (f h, map f t) in
       Cons (f h, map f t)

(* output is incorect evaluation order of f h and map f y is inverted *)
(* Moreover, the code of map has been unfolded, while the source was not *)
let map1 = lifting map_unfolded : ('a -> 'b) -> 'a listlist1 -> 'b listlist1
         
type 'a many = Zero | One of 'a | Many of 'a * 'a list

type 'a list2 =
  | Nil2
  | Cons2 of 'a * 'a * 'a list2

type ornament 'a list_list2 = 'a list => 'a list2
  | Nil -> Nil2
  | Cons (x, t) -> Cons2 (x, _, t) when t : 'a list_list2

let map2 = lifting map : ('a -> 'b) -> 'a list_list2 -> 'a list_list2
