type 'a list = Nil | Cons of 'a * 'a list

let rec map f l = match l with
  | Nil -> Nil
  | Cons(x, xs) -> Cons(f x, map f xs)

type 'a chunked_list = Nil2 | Cons2 of 'a * 'a * 'a chunked_list

type ornament 'a chunk_list : 'a list => 'a chunked_list with
  | Nil => Nil2
  | Cons(x1, (x2, xs) : 'a odd_list) => Cons2(x1, x2, xs)
and 'a odd_list : 'a list => 'a * 'a chunked_list with
  | Nil => ~  (* empty lists are not odd *)
  | Cons(x1, xs) => (x1, xs) when xs : 'a chunk_list

let chunk_map = lifting map : _ -> _ chunk_list -> _ chunk_list
and chunk_map_odd = lifting map : _ -> _ odd_list -> _ odd_list

