
type 'a gen = Pair of 'a gen * 'a gen | Value of 'a | Unit

let rec gen_map f x = match x with
  | Pair(u,v) -> Pair(gen_map f u, gen_map f v)
  | Value x -> Value (f x)
  | Unit -> Unit

let rec gen_fold z f x = match x with
  | Pair(u, v) -> f (gen_fold z f u) (gen_fold z f v)
  | Value x -> x
  | Unit -> z

type 'a list = Nil | Cons of 'a * 'a list

type ornament 'a gen_list : 'a gen => 'a list with
| Unit => Nil
| Pair(x, xs) => Cons(x, xs) when x : 'a gen_elem, xs : 'a gen_list
| Value x => ~
and 'a gen_elem : 'a gen => 'a with
| Value x => x
| Unit => ~
| Pair(x, y) => ~


#(mode autolift)
let map_list = lifting gen_map : ('a -> 'b) -> 'a gen_list -> 'b gen_list

type 'a tree = Leaf | Node of 'a * 'a tree * 'a tree

type ornament 'a gen_tree : 'a gen => 'a tree with
| Unit => Leaf
| Pair(v : 'a gen_value, (l, r) : 'a gen_treepair) => Node(v,l,r)
| Value x => ~
and 'a gen_value : 'a gen => 'a with
| Value x => x
| Unit => ~
| Pair(x,y) => ~
and 'a gen_treepair : 'a gen => 'a tree * 'a tree with
| Unit => ~
| Pair(l : 'a gen_tree, r : 'a gen_tree) => (l, r)
| Value x => ~

let map_tree = lifting gen_map : ('a -> 'b) -> 'a gen_tree -> 'b gen_tree


let fold_list = lifting gen_fold : _ -> _ -> _ gen_list -> _
let fold_tree = lifting gen_fold : _ -> _ -> _ gen_tree -> _
